
/*
 * This file is part of the FEddy package
 *
 *       Release 1.4.03  06/01/00
 *
 * Maintainance : Peter Marbaise (pmarbaise@gmx.de,2:2452/110.20)
 *
 * based on Oliver Graf's FEddi  Fido 2:2454/130.69
 *                                email ograf@informatik.uni-koblenz.de

 * Personal use allowed under the terms of the
 *
 *              GNU GENERAL PUBLIC LICENSE Version 2
 *              (see LICENSE for the complete text)
 *
 *-------------------------------------------------------------------
 *
 *    ENTER AT YOUR OWN RISK !!
 *
 * This source is without any documentation and can drive you mad.
 * In case of sudden epileptic seizures please call your doctor.
 *
 */
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include<sys/stat.h>
#include "proc.h"

void update_lastread (char *path, char *name);

int
main (int argc, char *argv[])		/* argv[1]==messagebasepath */
{
  char line[256];
  char path[1024];
  int l;
  FILE *id;

  if (argc < 2)
    return 1;

  l = strlen (argv[1]);
  if ( l < 1017 ) {
      strcpy (path, argv[1]);
      strcat (path, "/areas");
  }

  id = fopen (path, "r");
  
  strcpy(path,argv[1]);

  if (!id)
    return 1;

  while (!feof (id))
    {
      if (fgets (line, 256, id) != NULL)
	{
	  if (line[0] != '-')	/* if it's not a comment */
	    {
	      int len=strlen(line);
	      if((line[len-1]='\n'))line[len-1]=0;
	      update_lastread (path, line);
	    }
	}
    }
  return EXIT_SUCCESS;
}

void
update_lastread (char *path, char *line)
{
  char statname[1024];		/* name for stat() */
  char lastreadname[1024];	/* filename with lastread ptrs */
  FILE *id;
  struct stat buf;
  int lastread, total;
  int total_real;

  strcpy (statname, path);	/* compose stat name */
  strcat (statname, "/+");
  strcat (statname, line);
  strcat (statname, "/header");

  strcpy (lastreadname, path);	/* compose lastread name */
  strcat (lastreadname, "/.");
  strcat (lastreadname, line);

  if (lstat (statname, &buf) != -1)	/* obtain the file size */
    {
      total_real = buf.st_size / 224;	/* count number of messages */
      id = fopen (lastreadname, "r");
      fread (&lastread, sizeof (int), 1, id);
      fread (&total, sizeof (int), 1, id);
      fclose (id);
      if (total > total_real)
	{
	  lastread -= (total - total_real);
	  if (lastread < 1)
	    lastread = 1;
	  id = fopen (lastreadname, "w");
	  fwrite (&lastread, sizeof (int), 1, id);
	  fwrite (&total_real, sizeof (int), 1, id);
	  fclose (id);
	}
      else if (total < total_real)
	{
	  id = fopen (lastreadname, "w");
	  fwrite (&lastread, sizeof (int), 1, id);
	  fwrite (&total_real, sizeof (int), 1, id);
	  fclose (id);
	}
    }
}
